Description
Hi,
when building the toolkit as shared libraries (with MSC6), dcmdata_tests.exe fails to link:

tfilter.obj: unresolved external symbol "[...] DcmAttributeFilter::createlteratorBasedFilter([...]
)

(Once for "OFString const * const &" and once for "char const * * const &")
| guess the compiler expects an explicit instantiation of the createlteratorBasedFilter() function template to be exported from the DLL.
So far | have not found any good way around that, just the attached hack which | call a "patch".

Ideas?

History

#1 - 2013-04-04 14:29 - Jan Schlamelcher

That patch should work, but reduces the functionality for all other (non INSANE) compilers. Deducing the iterator type allows working with containers
that don't specify const_iterator, which ist clearly more generic. I'll see if i can find a solution that keeps deducing alive, otherwhise MSVC6 might get
another "Extrawurst"; possibly of the kind: "This features is not supported for ancient compilers."

#2 - 2013-04-08 17:02 - Jan Schlamelcher

For me even the proposed patch does not help as when the createlteratorBasedFilter-method is "fixed", the linker is missing the constructors
implementation from then on. It seems VC6 generally doesn't allow mixing template methods in non template classes that are to be exported in
shared objects.

Didn't you test the patch or did you use a different VC6 version? My experiments showed that the createlteratorBasedFilter method can also be
"fixed" by declaring it friend instead of static -- but that is impossible for constructors.

| think it is time to say: "generic construction of DcmAttibuteFilter" requires Visual Studio 2003 or later...

#3 - 2013-04-08 18:11 - Jan Schlamelcher
- Status changed from New to Feedback

- % Done changed from 0 to 70

I now used #if defined checks in the testfile, so the iterator based functionality is not tested when compiling with VC6.
Probably a note should be added to the documentation of the relevant constructors not to use them with VC6.

#4 - 2013-04-09 16:40 - Uli Schlachter
I think | remember fighting with VC6 for a while and the problem was that either VC6 or GCC didn't like the code. | think that my earlier patch worked,

but | cannot guarantee that | didn't forget to press the right button.

#5 - 2014-06-15 15:40 - Jan Schlamelcher
- Status changed from Feedback to Closed
- % Done changed from 70 to 100

The test has been fixed for quite some time now and nobody complained about my solution. So i think it's time to close it.
#6 - 2014-06-15 20:47 - Jorg Riesmeier

- Category set to Library

- Status changed from Closed to Reopened
- Target version changed from 3.6.1 to 3.6.2
- % Done changed from 100 to 80

This is probably because no one used this class with VC 6.0, and this class is not yet used anywhere within the DCMTK.

So, | reopened this issue with a new "target version" (next release).

#7 - 2016-07-21 15:42 - Jan Schlamelcher

- Status changed from Reopened to Closed

We have dropped support for VCB, therefore, this is no longer an issue.

#8 - 2016-07-21 15:43 - Jan Schlamelcher
- % Done changed from 80 to 100

Files
dcfilter.patch 1.82 KB 2013-01-15 Uli Schlachter
